#include <fstream>
#include <cmath>
#define MOD 666013
#define OPTIM1 1
#define OPTIM2 2
#define BRUT 3
#define BSEARCH 4
#define SOLUTIE 4
using namespace std;
ifstream f("echilateral.in");
ofstream g("echilateral.out");
long long n,m,a,b,i,j,k,st,dr,L,sol,lo,hi,mi,u,v,U,V;
double A,B,LD;
void optim1(),optim2(),brut(),bsearch();
int main()
{
    f>>n>>a>>b;
    if(SOLUTIE==OPTIM1)optim1();
    if(SOLUTIE==OPTIM2)optim2();
    if(SOLUTIE==  BRUT)  brut();
    if(SOLUTIE==BSEARCH)bsearch();
    return 0;
}
void optim1()
{
    for(L=a;L<=n&&L<=2*b;L++)
    {
        m=n+1-L;
        m=(m*(m+1)/2)%MOD;
        if(b>=L)st=0;
        else
        {
            B=(double)b;
            LD=(double)L;
            st=(long long)((3.0*LD-sqrt(12.0*B*B-3.0*LD*LD))/6.0);
            if(3*st*st-3*st*L+L*L>b*b)st++;
        }
        if(2*a<=L)dr=L/2;
        else
        {
            A=(double)a;
            LD=(double)L;
            dr=(long long)((3.0*LD-sqrt(12.0*A*A-3.0*LD*LD))/6.0);
            if(3*dr*dr-3*dr*L+L*L<a*a)dr--;
        }
        sol=(sol+(2*m*(dr-st+1)))%MOD;
        if(st==0)sol=(sol+MOD-m)%MOD;
        if(dr>0&&2*dr==L)sol=(sol+MOD-m)%MOD;
    }
    g<<sol<<'\n';
}
void optim2()
{
    for(L=v=V=a;L<=2*b&&L<=n;L++)
    {
        while(u>v){u--;v++;}
        while(U>V){U--;V++;}
        while(u>0&&u*u+v*v-u*v<a*a){u--;v++;}
        while(U<V&&U*U+V*V-U*V>b*b){U++,V--;}
        while((u+1<=v-1)&&(u+1)*(u+1)+(v-1)*(v-1)-(u+1)*(v-1)>=a*a){u++;v--;}
        while(U>0&&(U-1)*(U-1)+(V+1)*(V+1)-(U-1)*(V+1)<=b*b){U--;V++;}
        m=n+1-L;
        m=(m*(m+1)/2)%MOD;
        sol=(sol+2*m*(u-U+1))%MOD;
        if(U==0)sol=(sol+MOD-m)%MOD;
        if(u>0&&2*u==L)sol=(sol+MOD-m)%MOD;
        U++;u++;
    }
    g<<sol<<'\n';
}
void brut()
{
    for(L=a;L<=n&&L<=2*b;L++)
    {
        m=n+1-L;
        m=(m*(m+1)/2)%MOD;
        for(i=0,j=L;j;i++,j--)
        {
            k=i*i+j*j-i*j;
            if(a*a<=k&&k<=b*b)
                sol=(sol+m)%MOD;
        }
    }
    g<<sol;
}
void bsearch()
{
    for(L=a;L<=2*b&&L<=n;L++)
    {
        //cauta binar cea mai mare valoare i pentru care Lat(i,L-i)>=a*a
        lo=0;hi=L/2;
        if(3*hi*hi-3*L*hi+L*L>=a*a)
            i=hi;
        else
        {
            for(;hi-lo>1;)
            {
                mi=(hi+lo)/2;
                if(3*mi*mi-3*L*mi+L*L>=a*a)
                    lo=mi;
                else
                    hi=mi;

            }
            i=lo;
        }
        //cauta binat cea mai mica valoare j pentru care Lat(j)<=b
        lo=0;hi=L/2;
        if(L<=b)
            j=0;
        else
        {
            for(;hi-lo>1;)
            {
                mi=(hi+lo)/2;
                if(3*mi*mi-3*L*mi+L*L<=b*b)
                    hi=mi;
                else
                    lo=mi;

            }
            j=hi;
        }
        m=n+1-L;
        m=(m*(m+1)/2)%MOD;
        sol=(sol+2*m*(i-j+1))%MOD;
        if(j==0)sol=(sol+MOD-m)%MOD;
        if(i>0&&2*i==L)sol=(sol+MOD-m)%MOD;
    }
    g<<sol<<'\n';
}
