#include<bits/stdc++.h>

using namespace std;

#define dbg(x) (cout<<#x<<" = "<<(x)<<'\n')

typedef long long int lld;
const int INF = (1LL << 30) - 1;
const lld LINF = (1LL << 62) - 1;
const int NMAX = 1e3;

int N;
vector<pair<int, int>> P;

int main() {
	cin.sync_with_stdio(false);

	#ifndef ONLINE_JUDGE
	freopen("mindist.in", "r", stdin);
	freopen("mindist.out", "w", stdout);
	#endif

	scanf("%d", &N);

	for (int i = 1, x, y; i <= N; i++) {
		scanf("%d%d", &x, &y);

		int dmin = INF;

		for (auto p : P)
			dmin = min(dmin, abs(p.first - x) + abs(p.second - y));

		if (dmin == INF) dmin = 0;
		printf("%d\n", dmin);

		P.push_back({x, y});
	}

	return 0;
}