#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

typedef pair<int, int> point;

int main() {

  ifstream in("nperechi.in");
  ofstream out("nperechi.out");

  ll a, b, c, d;

  in >> a >> b >> c >> d;

  point p1({a, c}),
        p2({b, d});
  //these are the two boundary points

  const ll area = abs(a * d - b * c);
  //this is the area of the parallelogram
  //x1y2 - x2y1


  //A = i + b/2 - 1
  //Area = interior_points + boundary_points/2 - 1
  //* all by 2
  //2A =  2i + b - 2
  //i is the number of solutions
  //2i = 2A - b + 2
  //i = (2A - b + 2) / 2
  //we know 2A, we have to find the boundary points

  ll boundary = __gcd(a, c) + __gcd(b, d);
  //the number of lattice points on the line between (0, 0) and (x, y) is 
  //related to the gcd of x and y

  ll i = (2 * area - 2 * boundary + 2) / 2;

  out << i << "\n";
  return 0;
}
