#include <iostream>
#include <cmath>
#include <iomanip>

#include "header.h"

#define eps 1e-7
#define D sqrt((x[i]-x[j])*(x[i]-x[j])+(y[i]-y[j])*(y[i]-y[j]))

using namespace std;

int m,i,j,A=0,B=1;
double a,b,c,d,x[100010],y[100010];

void recover(int m) {
    a = query(A,B);
    y[0]=0.0;x[0]=0.0;y[1]=0.0;x[1]=a;
    for(i=m-1;i>1;i--)
    {
        b=query(A,i);c=query(B,i);
        if(fabs(a+b-c)<eps){x[i]=-b;y[i]=0.0;continue;}
        if(fabs(a+c-b)<eps){x[i]= b;y[i]=0.0;continue;}
        if(fabs(b+c-a)<eps){x[i]= b;y[i]=0.0;continue;}
        x[i]=(a*a+b*b-c*c)/(2.0*a);y[i]=sqrt(b*b-x[i]*x[i]);j=i;
    }
    for(i=j+1;i<m;i++)if(y[i]>eps){d=query(i,j);if(fabs(D-d)>eps)y[i]=-y[i];}
    sendRecovered(x, y);
}
