#include <cstdio>
#include <cstdlib>
#include <algorithm>
using namespace std;

const int nmax = 410;

int n, k, sza, szb, sz, color, cntColor[nmax][2], A, B;
double probChoose[nmax][nmax];
double totalWays[nmax][nmax];
double dp[nmax][nmax][nmax];
double fact[nmax];

int main()
{
	freopen("expected.in", "r", stdin);
	freopen("expected.out", "w", stdout);
	
	scanf("%i %i %i %i", &n, &k, &sza, &szb);
	for (int i = 1; i <= n; ++ i)
	{
		scanf("%i %i", &color, &sz);
		cntColor[color][sz] ++;
		if (sz == 0) A ++;
		else B ++;
	}
	
	probChoose[0][0] = 1.0;
	for (int i = 0; i <= A; ++ i)
		for (int j = 0; j <= B; ++ j)
			if (!(i == 0 && j == 0))
			{
				probChoose[i][j] = 0.0;
				if (i > 0)
					probChoose[i][j] += probChoose[i - 1][j] * 1.0 * (A - i + 1) * sza / ((A - i + 1) * sza + (B - j) * szb);
				if (j > 0)
					probChoose[i][j] += probChoose[i][j - 1] * 1.0 * (B - j + 1) * szb / ((A - i) * sza + (B - j + 1) * szb);
			}
	
	fact[0] = 1.0; 
	for (int i = 1; i < nmax; ++ i)
		fact[i] = 1.0 * fact[i - 1] * i;
	
	for (int i = 0; i <= A; ++ i)
		for (int j = 0; j <= B; ++ j)
		{
			totalWays[i][j] = fact[A];
			totalWays[i][j] /= fact[A - i];
			totalWays[i][j] *= fact[B];
			totalWays[i][j] /= fact[B - j];
		}
	
	dp[0][0][0] = 1.0 / totalWays[0][0];
	for (int i = 1; i <= n; ++ i)
		for (int a = 0; a <= A; ++ a)
			for (int b = 0; b <= B; ++ b)
				if (a + b <= i)
				{
					dp[i][a][b] = dp[i - 1][a][b];
					dp[i][a][b] += cntColor[i][0] * a * (dp[i - 1][a - 1][b] / totalWays[a][b]) * totalWays[a - 1][b];
					dp[i][a][b] += cntColor[i][1] * b * (dp[i - 1][a][b - 1] / totalWays[a][b]) * totalWays[a][b - 1];
				}
	
	double ans = 0.0;
	for (int a = 0; a <= A && a <= k; ++ a)
	{
		int b = k - a;
		if (0 <= b && b <= B)
			ans += probChoose[a][b] * (1 - dp[n][a][b]);
	}
	
	printf("%.20f\n", ans);
	
	return 0;
}
		
