#include<bits/stdc++.h>
#include "header.h"

using namespace std;

typedef long long int lld;
const int INF = (1LL << 30) - 1;
const lld LINF = (1LL << 62) - 1;

// int makeStep(double alpha) {return -1;};
int directionSign = -1;
double cauta_binar();

void play() {
	cin.sync_with_stdio(false);

	double alpha = cauta_binar();
	alpha += directionSign * M_PI * 0.5;
	while (makeStep(alpha) != -1);
}

double cauta_binar() {
	double lo = 0, mi, hi = 2 * M_PI;
	double unDa;
	double unNu;

	for (; fabs(lo - hi) >= 5e-6;) {
		mi = (lo + hi) / 2.0;
		int reply = makeStep(mi);
		if (reply == -1) exit(0);
		makeStep(-M_PI + mi);
		if (reply == 1) lo = mi, unDa = mi;
		if (reply == 0) hi = mi, unNu = mi;
	}

	if (unDa > unNu) directionSign = 1;

	return mi;
}
