#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
using namespace std;

const int nmax = 100010, inf = 0x3f3f3f3f;

int n, type, x, y;
vector<pair<int, int> > p;

int main()
{
	freopen("mindist.in", "r", stdin);
	freopen("mindist.out", "w", stdout);

	scanf("%i", &n);
	for (int i = 1; i <= n; ++ i)
	{
		int mindist = inf;
		scanf("%i %i", &x, &y);
		for (int j = 0; j < p.size(); ++ j)
			mindist = min(mindist, abs(p[j].first - x) + abs(p[j].second - y));
		p.push_back(make_pair(x, y));
		if (mindist == inf) mindist = 0;
		printf("%d\n", mindist);	
	}

	return 0;
}
