#include <bits/stdc++.h>

using namespace std;

int main(int argc, char **argv) {
  vector<string> args(argv + 1, argv + argc);

  if(args.size() != 7) {
    fprintf(stderr, "Usage: %s N K A B prob_big diff_colors per\n", argv[0]);
    exit(1);
  }

  int n = stoi(args[0]),
      k = stoi(args[1]);

  int sA = stoi(args[2]),
      sB = stoi(args[3]);

  double p = stof(args[4]);

  printf("%d %d\n", n, k);

  printf("%d %d\n", sA, sB);


  int ncol = stoi(args[5]);

  int per = stoi(args[6]);

  assert(ncol <= n);

  //fprintf(stderr, "n = %d, k = %d, a = %d, b = %d, p = %f, colors = %d, per = %d\n\n", n, k, sA, sB, p, ncol, per);

  vector<int> color;
  color.resize(n);

  int at = 0;
  for(int i = 1; i <= ncol; ++i) {
    for(int j = 0; j < per; ++j) {
      color[at] = i;
      ++at;
      if(at > n )
        break;
    }
  }

  normal_distribution<double> col(n / 2.0, n / 2.0 - 1);

  random_device rd;
  mt19937 gen(rd());

  while(at < n) {
    int now;

    do {
      now = (int)(abs(col(gen)));
    } while(now < 1 || now > n);

    assert(now >= 1 && now <= n);

    color[at] = now;
    at++;
  }

  uniform_int_distribution<int>  sdist(1, 10000);

  uniform_real_distribution<double> ssize(0.0, 1.0);

  vector<bool> size;
  size.resize(n);
  for(int i = 0; i < n; ++i) {
    if(ssize(gen) <= p)
      size[i] = 1;
    else
      size[i] = 0;
  }


  for(int i = 0; i < n; ++i)
    printf("%d %d\n", color[i], (int)size[i]);

  return 0;
}
